
/**
 *
 */
class Pile {
    private int int_array[];
    private int array_size;
    private int stack_head_index;

    /**
     * [setSize description]
     * @param int size [description]
     */
    private void setSize(int size) {
        array_size = size;
    }

    /**
     * [getSize description]
     * @return [description]
     */
    private int getSize() {
        return array_size;
    }

    /**
     * [setHeadIndex description]
     * @param int index [description]
     */
    private void setHeadIndex(int index) {
        stack_head_index = index;
    }

    /**
     * [getHeadIndex description]
     * @return [description]
     */
    private int getHeadIndex() {
        return stack_head_index;
    }

    /**
     * [Pile description]
     * @param int size [description]
     */
    Pile(int size) {
        int_array = new int[size];
        setSize(size);
        setHeadIndex(0);
    }

    /**
     * [empiler description]
     * @param int value [description]
     */
    public void empiler(int value) {
        if (!plein()) {
            int_array[stack_head_index] = value;
            stack_head_index++;
        } else {
            System.out.println("La pile est pleine");
        }
    }

    /**
     * [depiler description]
     * @return [description]
     */
    public int depiler() {
        if (!vide()) {
            stack_head_index--;
            return int_array[stack_head_index];
        } else {
            return -1;
        }
    }

    /**
     * [plein description]
     * @return [description]
     */
    private boolean plein() {
        return (getHeadIndex() >= getSize());
    }

    /**
     * [vide description]
     * @return [description]
     */
    private boolean vide() {
        return (getHeadIndex() == 0);
    }

    /**
     * [afficher description]
     */
    public void afficher() {
        for (int i = 0; i < getSize(); i++) {
            System.out.println("element " + i + " " + int_array[i]);
        }
    }

    /**
     * The main() function
     * @param String[] args main() function arguments array
     */
    public static void main(String[] args) {
        Pile stack = new Pile(5);

        stack.empiler(3);
        stack.empiler(5);
        stack.empiler(4);
        stack.empiler(7);
        stack.empiler(8);

        stack.afficher();

        System.out.println("Stack index " + stack.getHeadIndex());
        System.out.println("Stack head value " + stack.depiler());
        System.out.println("Stack index " + stack.getHeadIndex());
        System.out.println("Stack head value " + stack.depiler());
        System.out.println("Stack index " + stack.getHeadIndex());
        System.out.println("Stack head value " + stack.depiler());
        System.out.println("Stack index " + stack.getHeadIndex());
        System.out.println("Stack head value " + stack.depiler());
        System.out.println("Stack index " + stack.getHeadIndex());
        System.out.println("Stack head value " + stack.depiler());
        System.out.println("Stack index " + stack.getHeadIndex());
        System.out.println("Stack head value " + stack.depiler());
        System.out.println("Stack index " + stack.getHeadIndex());

        stack.afficher();
    }
}
